//
//  HttpServer.m
//  WHM08_OSX
//
//  Created by 富樫 豊彦 on 2014/01/14.
//  Copyright (c) 2014年 富樫 豊彦. All rights reserved.
//

#import "HttpServer.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>

@implementation HttpServer

- (IBAction)server:(id)sender
{
    int fd;
    struct sockaddr_in stSockAddr;
    
    fd = socket(AF_INET, SOCK_STREAM, 0);
    if (!fd) {
        NSLog(@"can not create socket");
        return;
    }
    
    memset(&stSockAddr, 0, sizeof(stSockAddr));
    stSockAddr.sin_family = AF_INET;
    stSockAddr.sin_port = htons(4444);
    stSockAddr.sin_addr.s_addr = htonl(INADDR_ANY);
    if(bind(fd, (struct sockaddr *)&stSockAddr, sizeof(stSockAddr)) < 0) {
        NSLog(@"error bind failed");
        return;
    }
    
    if(listen(fd, 10) < 0) {
        NSLog(@"error listen failed");
        return;
    }
    
    for(; ;) {
        int c;
        char *msg1 = "HTTP/1.0 200 OK\nCache-Control: private\nContent-Type: text/html\nServer: tog/0.1\nConnection: Close\n\n<html><head><title>WHM0.8</title></head><body><table border=1><tr><th>Channel</th><th>Energy</th><th>Effective power</th><th>Apparent power</th><th>Power factor</th><th>Voltage</th><th>Current</th><th>Frequency</th></tr>";
        char *msg2 = "</table></body></html>\n\n";
        char buf[10000];
        int i;
        struct recvData *p;
        
        c = accept(fd, NULL, NULL);
        if(c < 0) {
            NSLog(@"error accept failed");
            return;
        }
        read(c, buf, sizeof(buf));
        
        strcpy(buf, msg1);
        p = self.data;
        if (p) {
            for(i = 0; i < CH_COUNT; i++) {
                float   apparentPower;
                float   powerFactor;
                char    lin[1000];

                apparentPower = p->current * p->voltage;
                powerFactor   = p->power / apparentPower * 100 + 0.5;
                sprintf(lin, "<tr><td>%d</td><td>%.2fkWh</td><td>%.0fW</td><td>%.0fVA</td><td>%.0f%%</td><td>%.0fV</td><td>%.2fA</td><td>%.0fHz</td></tr>", i+1, p->energyOfMonth, p->power, apparentPower, powerFactor, p->voltage, p->current, p->frequency);
                strcat(buf, lin);
                p++;
                NSLog(@"line");
            }
        }
        strcat(buf, msg2);
        write(c, buf, strlen(buf));
        NSLog(@"sended");

        shutdown(c, 2);
        close(c);
    }
}

- (id)init
{
    self = [super init];
    if (self) {
        [NSThread detachNewThreadSelector:@selector(server:) toTarget:self withObject:nil];
    }
    return self;
}

- (void)start:(struct recvData *)data
{
    self.data = data;
    return;
}

- (void)stop
{
    if (self.pid) {
            kill(self.pid, SIGQUIT);
    }
    return;
}

@end
